package org.gcube.common.authorizationservice.cl;

import static org.gcube.common.authorization.client.Constants.authorizationService;

import java.util.ArrayList;
import java.util.List;

import org.gcube.common.authorization.client.exceptions.ObjectNotFound;
import org.gcube.common.authorization.library.policies.Action;
import org.gcube.common.authorization.library.policies.Policy;
import org.gcube.common.authorization.library.policies.ServiceAccess;
import org.gcube.common.authorization.library.policies.User2ServicePolicy;
import org.gcube.common.authorization.library.policies.Users;
import org.gcube.common.authorization.library.provider.UserInfo;
import org.junit.Test;
public class CallTest {

	
	@Test
	public void call()  throws Exception{
		try{
			System.out.println(authorizationService().get("82a84741-debe-4c90-a907-c429c8272071"));
		}catch(ObjectNotFound onf){
			onf.printStackTrace();
		}
	}
	
	@Test
	public void requestToken()  throws Exception {
		//ScopeProvider.instance.set("/gcube/devsec");
		String token = authorizationService().generateToken(new UserInfo("luca.frosini", new ArrayList<String>()), "/gcube");
		System.out.println("token is: "+token);
	}
		
	@Test
	public void addPolicy()  throws Exception {
		List<Policy> policies = new ArrayList<Policy>();
		policies.add(new User2ServicePolicy("/gcube/devsec", new ServiceAccess(), Users.one("lucio.lelii"), Action.ACCESS ));
		authorizationService().addPolicies(policies);
	}
	
	@Test
	public void getPolicies()  throws Exception{
		List<Policy> policies = authorizationService().getPolicies("/gcube/devsec");
		System.out.println(policies);	
	}
	
	@Test
	public void removePolicy()  throws Exception {
		authorizationService().removePolicies(2, 3, 4);
	}
}
